#/usr/bin/perl -w

$path=$ARGV[0];
$pathDwgsim=$ARGV[1];
$pathVelvet=$ARGV[2];
$pathMetaVelvet=$ARGV[3];
$pathLibSVM=$ARGV[4];

$input = $ARGV[5];
$kmer = $ARGV[6];
$fileOutput = "CommandAll.sh";
$coverage=30;

open OUTPUT, ">$fileOutput";
print OUTPUT "#!/bin/sh \n";
print OUTPUT "cd ",$path,"\n";
print OUTPUT "tar -zcvf ",$input,".tar.gz ",$input,"\n";
print OUTPUT "mv ",$input,".tar.gz metaphlan \n";
print OUTPUT "cd metaphlan \n";
print OUTPUT "tar zxvf ",$input,".tar.gz --to-stdout | ./metaphlan.py --bowtie2db bowtie2db/mpa --bt2_ps very-sensitive --input_type multifasta > ",$input,"Profile \n";

print OUTPUT "cd ",$path,"\n";
print OUTPUT "perl ReadTaxon.perl ",$path,"/metaphlan/",$input,"Profile ",$path," ",$pathDwgsim," ",$coverage,"\n";

print OUTPUT "sh ./GenerateSimulatedData.sh \n";

print OUTPUT "cd Reads \n";
print OUTPUT "cat *.fastq > ReadsAll \n";

print OUTPUT "cd ",$path,"\n";
print OUTPUT "mkdir ",$input,"LearningModel \n";
print OUTPUT "./",$pathVelvet,"/velveth ",$input,"LearningModel ",$kmer," -shortPaired -fastq Reads/ReadsAll \n";
print OUTPUT "./",$pathVelvet,"/velvetg ",$input,"LearningModel -ins_length 500 -read_trkg yes -exp_cov auto \n";
print OUTPUT "./",$pathMetaVelvet,"/meta-velvete ",$input,"LearningModel -ins_length 500 \n";

print OUTPUT "cd LearningModelFeatures/BLAST_map \n";
print OUTPUT "perl eval.pl -i ",$path,"/",$input,"LearningModel/meta-velvetg.subgraph__ChimeraNodeCandidates -n ",$input,"LearningModel -d ",$path,"/ReferenceGenomes.fasta -p ",$input,"LearningModel \n";

print OUTPUT "cd ",$path,"\n";
print OUTPUT "perl LearningModelFeatures/FeatureExtract.perl ",$input,"LearningModel/meta-velvetg.subgraph__TitleChimeraNodeCandidates LearningModelFeatures/BLAST_map/",$input,"LearningModel.long-scafs.blast ",$input,"LearningModel/Features3Class ",$input,"LearningModel/ChimeraTrue ",$input,"LearningModel/ChimeraNodeName \n";

print OUTPUT "cp ",$input,"LearningModel/Features3Class ",$input,"LearningModel/",$input,"LearningModel\n";

print OUTPUT "cd ",$pathLibSVM,"/tools \n";
print OUTPUT "python easy.py ",$path,"/",$input,"LearningModel/",$input,"LearningModel\n";

print OUTPUT "cd ",$path,"\n";
$num_args = $#ARGV + 1;
$insertFinish=6;
print OUTPUT "./",$pathVelvet,"/velveth ",$input,"Assembly ",$kmer," ";
for ($index=7;$index<$num_args;$index++)
{
	if ($ARGV[$index]>0) 
	{$insertFinish=$index;} else
	{print OUTPUT $ARGV[$index]." ";}
}
print OUTPUT "\n";


print OUTPUT "./",$pathVelvet,"/velvetg ",$input,"Assembly -read_trkg yes -exp_cov auto ";
if ($insertFinish>6){
	for ($index=7;$index<=$insertFinish;$index++)
	{
		if ($index>7){
		print OUTPUT "-ins_length",$index-6," ",$ARGV[$index]," ";
		} else {
		print OUTPUT "-ins_length ",$ARGV[$index]," ";
		}
	
	}
}
print OUTPUT "\n";



print OUTPUT "./",$pathMetaVelvet,"/meta-velvete ",$input,"Assembly ";
if ($insertFinish>6){
	for ($index=7;$index<=$insertFinish;$index++)
	{
		if ($index>7){
		print OUTPUT "-ins_length",$index-6," ",$ARGV[$index]," ";
		} else {
		print OUTPUT "-ins_length ",$ARGV[$index]," ";
		}
	
	}
}
print OUTPUT "\n";


print OUTPUT "perl LearningModelFeatures/FeatureExtractPredict.perl ",$input,"Assembly/meta-velvetg.subgraph__TitleChimeraNodeCandidates ",$input,"Assembly/Features ",$input,"Assembly/Features3Class ",$input,"Assembly/ChimeraNodeName \n";

print OUTPUT "./",$pathLibSVM,"/svm-scale -r ",$pathLibSVM,"/tools/",$input,"LearningModel.range ",$input,"Assembly/Features3Class > ",$input,"Assembly/Features3Class.scale \n";
print OUTPUT "./",$pathLibSVM,"/svm-predict ",$input,"Assembly/Features3Class.scale ",$pathLibSVM,"/tools/",$input,"LearningModel.model ",$input,"Assembly/ClassificationPredict \n";

print OUTPUT "./",$pathMetaVelvet,"/meta-velvetg ",$input,"Assembly ";
if ($insertFinish>6){
	for ($index=7;$index<=$insertFinish;$index++)
	{
		if ($index>7){
		print OUTPUT "-ins_length",$index-6," ",$ARGV[$index]," ";
		} else {
		print OUTPUT "-ins_length ",$ARGV[$index]," ";
		}
	
	}
}
print OUTPUT "\n";

close OUTPUT;
